//ConvertirReperes_201f.js
// 19.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Ce script convertit des repres page en repres planche (et vice versa)

// activer l'affichage de dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// le document, la planche et le calque actuelles
var curDoc = app.documents[0];
var curSpr = app.activeWindow.activeSpread;
var curLayer = app.activeWindow.activeLayer.index;

// tester la slection
selItems = app.selection;
nItems = selItems.length;
var remSel = false;

// s'il n'y a pas de slection, poser la question
if (nItems == 0) {
	var userDec = confirm ("Convertir les repres de la planche actuelle?");
	if (userDec == false) {
		// aprs le clic sur "No" arrter l'excution
		exit();
	}
	else {
		// aprs le clic sur "Yes" slectionner tous les repres
		curSpr.guides.everyItem().select();
		selItems = app.selection;
		nItems = selItems.length;
		remSel = true;
	}
}

// dclarer des variables
var curCol;
var curItem;
var curProps;
var ftPage;
var isDone;
var lock;
var newGuide;
var orient;
var posList = new Array ();

if (nItems > 0) {
	// une boucle  travers la slection
	for (var i=0; i<nItems; i++) {
		curItem = selItems[i];
		// tester le type de l'objet actuel
		if (curItem.constructor.name == "Guide") {
			// mmoriser des attributs
			curProps = curItem.properties;
			ftPage = curProps.fitToPage;
			orient = curProps.orientation;
			// inverser page ou planche
			if (ftPage) {
				// quand il s'agit d'un repre page horizontal
				if (orient == 1752134266) {
					curPos = curProps.location;
					isDone = false;
					// vrifier si la liste contient la position actuelle
					for (var k=0; k<posList.length; k++) {
						if (curPos == posList[k]) {
							isDone = true;
							break;
						}
					}
					try {
						// supprimer le repre actuel quand il y a dj un repre  la mme position
						if (isDone) {
							curItem.remove();
						}
						else {
							// sinon, le convertir en repre planche
							curItem.properties = {fitToPage:false};
							// ajouter la position  la liste
							posList.push(curPos);
						}
					}
					catch (e) {
					}
				}
				else {
					// sinon, le convertir en repre planche
					curItem.properties = {fitToPage:false};
				}
			}
			else {
				try {
					curItem.properties = {fitToPage:true};
					// quand il s'agit d'un repre planche horizontal
					// crer un repre aux pages  ct
					if (orient == 1752134266) {
						curCol = curProps.guideColor;
						curPos = curProps.location;
						curThr = curProps.viewThreshold;
						lock = curProps.locked;
						doLock = false;
						// quand rien n'tait slectionn, activer le calque du repre actuel et le dverrouiller si ncessaire
						if (remSel) {
							actLayer = curItem.itemLayer.name;
							app.activeWindow.activeLayer = curDoc.layers.item(actLayer);
							if (curDoc.layers.item(actLayer).locked == true) {
								curDoc.layers.item(actLayer).locked = false;
								doLock = true;
							}
						}
						// une boucle  travers les pages et crer un repre page
						for (var k=1; k<curSpr.pages.length; k++) {
							newGuide = curSpr.pages[k].guides.add(undefined, {orientation:HorizontalOrVertical.horizontal, location:curPos});
							newGuide.properties = {fitToPage:true, guideColor:curCol, viewThreshold:curThr, locked:lock};
						}
						// verrouiller le calque, s'il tait verrouill
						if (doLock) {
							curDoc.layers.item(actLayer).locked = true;
						}
					}
				}
				catch (e) {
				}
			}
		}
	}
}

// dselectionner s'il n'y avait pas de slection au dbut
if (remSel) {
	app.selection = null;
}

// slectionner le calque initial
app.activeWindow.activeLayer = curDoc.layers[curLayer];
